package com.nokia.siteinfo.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.boot.jdbc.DataSourceBuilder;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.jdbc.core.JdbcTemplate;

import javax.sql.DataSource;

/**
 * 数据源配置
 */
@Slf4j
@Configuration
public class DataSourceConfig {

    @Bean
    public DataSource dataSource1(TaskConfig taskConfig)
    {
        return DataSourceBuilder.create()
                .driverClassName(taskConfig.getDriverClassName1())
                .url(taskConfig.getJdbcUrl1())
                .username(taskConfig.getDbUsername1())
                .password(taskConfig.getDbPassword1())
                .build();
    }

    @Bean
    public DataSource dataSource2(TaskConfig taskConfig)
    {
        return DataSourceBuilder.create()
                .driverClassName(taskConfig.getDriverClassName2())
                .url(taskConfig.getJdbcUrl2())
                .username(taskConfig.getDbUsername2())
                .password(taskConfig.getDbPassword2())
                .build();
    }

    @Bean
    public DataSource dataSource3(TaskConfig taskConfig)
    {
        return DataSourceBuilder.create()
                .driverClassName(taskConfig.getDriverClassName3())
                .url(taskConfig.getJdbcUrl3())
                .username(taskConfig.getDbUsername3())
                .password(taskConfig.getDbPassword3())
                .build();
    }

    @Bean
    public JdbcTemplate jdbcTemplate1(DataSource dataSource1) {
        return new JdbcTemplate(dataSource1);
    }

    @Bean
    public JdbcTemplate jdbcTemplate2(DataSource dataSource2) {
        return new JdbcTemplate(dataSource2);
    }

    @Bean
    public JdbcTemplate jdbcTemplate3(DataSource dataSource3) {
        return new JdbcTemplate(dataSource3);
    }
}
